/* DON'T EVER WRITE CODE LIKE THIS! It demonstrates all kinds of bad coding
practices :-) */
/* gcc gen1.c -lbfd -lopcodes */

#include <bfd.h>
#include <stdio.h>
#include <dis-asm.h>
#include <stdarg.h>

char *thebuf=NULL;

static int myprint VPARAMS ((void *f, const char *format, ...))
{
  char *buf, *oldthebuf;
  VA_OPEN (args, format);
  VA_FIXEDARG (args, void *, f);
  VA_FIXEDARG (args, const char *, format);
  vasprintf (&buf, format, args);
  if (buf == NULL) exit(2);
  oldthebuf=thebuf;
  if (oldthebuf==NULL) asprintf (&thebuf, "%s", buf);
  else asprintf (&thebuf, "%s%s", oldthebuf, buf);
  free(buf);
  free(oldthebuf);
  VA_CLOSE (args);
  return 0;
}


bfd *b;
asection *a;
unsigned char *data;
int pushas=0;
struct disassemble_info dinfo;
disassembler_ftype dis;

void display(unsigned long eip, int len) {
  int i;
  printf("%x: ", eip);
  for (i=0; i<len; i++) printf("%02x ", data[eip-a->vma+i]);
  for (; i<9; i++) printf("   ");
  printf("%s\n", thebuf);
}

int mydis(unsigned long eip, struct disassemble_info *dinfo) {
  int r;
  if (thebuf) free(thebuf); thebuf=NULL;
  r=dis(eip, dinfo);
  if (r<0) {
    printf("Unable to disassemble at 0x%x, aborting\n", eip);
    exit(4);
  }
  return r;
}

void blank(unsigned long from, unsigned long to) {
  unsigned long i;
  for (i=from-a->vma; i<to-a->vma; i++) data[i]=0x90;
}

char *check_dummy(unsigned long *rva, int len, struct disassemble_info *dinfo) {
  unsigned long sum;
  unsigned long va;
  int i, l;
  char *oldthebuf;
  
  sum=0;
/* Is it the exception block? */
  for (i=0; i<104; i++) sum=((sum<<13)|(sum>>19)+data[(*rva+len-1-a->vma)+i])^0xd0b3ded0;
  if (sum==0x7206d84) {
    char *q;
    asprintf(&q, "Exception block 0x%x-0x%x", *rva, *rva+len+103);
    blank(*rva, *rva+len+103);
    *rva+=len+103;
    return q;
  }
  
/* Is it the pusha/.../popa dummy code */
  va=*rva; oldthebuf=thebuf; thebuf=NULL;
  while(1) {
    l=mydis(va, dinfo);
    if (strstr(thebuf, "popa")) {
      char *q;
      free(oldthebuf);
      asprintf(&q, "Dummy block 0x%x-0x%x", *rva, va+l-1);
      blank(*rva, va+l);
      *rva=va+l;
      return q;
    }
    else if (strstr(thebuf, "jmp")) {
      if (data[va-a->vma+l-2]!=0xeb) exit(3);
      va+=l+*(signed char*)(data+va-a->vma+l-1);
    }
/* Dummy instructions are not allowed to use memory references, except for lea */
    else if (strstr(thebuf, "[") && !strstr(thebuf, "lea")) exit(5);
    else va+=l;
  }
  thebuf=oldthebuf;
  return NULL;
}

void dedummify(unsigned long start, unsigned long end) {
  unsigned long eip, neip;
  int len;
  int stop=0;

  for (eip=start; eip>=start && eip<end && !stop; ) {
    len=mydis(eip, &dinfo);

/* Analyse the instruction */
/* Is it a pusha? If so, check for dummy code */
    if (strstr(thebuf, "pusha")) {
      if (++pushas==2) {
        char *q;
        neip=eip;
        if (q=check_dummy(&neip, len, &dinfo)) {
          pushas--;
          printf("DUMMY (%s)\n", q);
          continue;
        }
        else neip=eip+len;
      }
      else neip=eip+len;
    }
/* Is it a call ? */
    else if (strstr(thebuf, "call ")) {
    /* Is it the trivial call-pop sequence? */
      display(eip, len); neip=eip+5+*(unsigned long*)(data+eip-a->vma+len-4);
      len=mydis(neip, &dinfo);
      if (!strstr(thebuf, "pop")) {
        dedummify(neip, end);
        eip+=len;
      }
      else eip=neip;
      continue;
    }
/* Or a conditional jump ? */
    else if (strstr(thebuf, "je ") || strstr(thebuf, "jne ")) {
      display(eip, len); 
      neip=eip+len+*(signed char*)(data+eip-a->vma+len-1);
      dedummify(eip+len, end);
      eip=neip; continue;
    }
    else if (strstr(thebuf, "ret")) {
      stop=1;
    }
    else if (strstr(thebuf, "jmp")) {
      if (data[eip-a->vma+len-2]!=0xeb) stop=1;
      else {
        neip=eip+len+*(signed char*)(data+eip-a->vma+len-1);
      }
    }
    else if (strstr(thebuf, "nop")) {
      eip+=len;
      continue;
    }
    else {
      neip=eip+len;
    }

    display(eip, len);
    eip=neip;
  }
}

int main() {
  char **m;
  bfd_arch_info_type *ainfo;

  bfd_init();
  b=bfd_openr("0x90-1.exe", NULL);
  bfd_check_format_matches (b, bfd_object, &m);

  INIT_DISASSEMBLE_INFO(dinfo, stdout, fprintf);
  b->arch_info=bfd_scan_arch ("i386");
  
  dis=disassembler(b);

  a=b->sections->next; /* We are interested only in second section */
  dinfo.flavour = bfd_get_flavour (b);
  dinfo.arch = bfd_get_arch (b);
  dinfo.mach = bfd_get_mach (b);
  dinfo.disassembler_options = "intel";
  dinfo.octets_per_byte = 1;
  dinfo.buffer_length=bfd_get_section_size_before_reloc(a);
  data=dinfo.buffer=(bfd_byte*)malloc(dinfo.buffer_length);
  bfd_get_section_contents (b, a, dinfo.buffer, 0, dinfo.buffer_length);
  dinfo.buffer_vma=a->vma;
  dinfo.section=a;
  dinfo.fprintf_func=(fprintf_ftype)myprint;
  dinfo.stream=NULL;

  dedummify(a->vma, a->vma+dinfo.buffer_length);
  free(dinfo.buffer);
  return 0;
}
