// coded by bilbo
// useful function to memory-map a file
#include "map.h"

	// globals
HANDLE hFile, hMap;
LPVOID addy;
PBYTE mapbias;

PBYTE
map(LPSTR filename)
{
	hFile = CreateFile(filename, GENERIC_READ|GENERIC_WRITE, 0, 0,
		OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
	if (hFile == INVALID_HANDLE_VALUE) Error("CreateFile", 0);

	hMap = CreateFileMapping(hFile, 0, PAGE_READWRITE, 0, 0, 0);
	if (!hMap) Error("CreateFileMapping", 0);

	addy = MapViewOfFile(hMap, FILE_MAP_WRITE, 0, 0, 0);
	if (!addy) Error("MapViewOfFile", 0);

	return addy;
}

void
unmap(void)
{
	if (addy) if (!UnmapViewOfFile(addy)) Error("UnmapViewOfFile", 0);
	if (hMap) if (!CloseHandle(hMap)) Error("CloseHandle_hMap", 0);
	if (!CloseHandle(hFile)) Error("CloseHandle_hFile", 0);
}

void
Error(LPSTR api, int error_type)
{
	ULONG errorCode;
	UCHAR errorBuffer[80];

	errorCode = error_type ? error_type : GetLastError();

	FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, NULL, errorCode, 0,
		errorBuffer, sizeof(errorBuffer), NULL);

	printf("\tError in %s(): %u %s", api, errorCode, errorBuffer);
	exit(0);
}
