/* hide.idc

   Hides areas of codes between two addresses given in an input
   text file.

   Eloy Paris <peloy@chapus.net>
   November 2004
*/

#include <idc.idc>

static main(void)
{
    auto fh;
    auto fname;
    auto pusha, popa;
    auto start, end;
    auto success;
    auto count;

    fname = "/home/elparis/Desktop/scan33/addresses.txt";

    fh = fopen(fname, "r");
    if (fh == 0) {
	Message("Can't open %s\n", fname);
	return;
    }

    Message("Hiding no-operation zones...");

    for (count = 0; 1; count++) {
	pusha = readstr(fh);
	if (pusha == -1)
	    break;

	popa = readstr(fh);

	start = xtol(substr(pusha, 7, 15) );
	end = xtol(substr(popa, 7, 15) );

	success = HideArea(start, end + 1, "no-operation zone", 0, 0, 0);
	if (success == 0) {
	    Message("\nError trying to hide no-op zone between 0x%x and 0x%x\n", start, end);
	    break;
	}
    }

    Message("done.\nHid %d no-operation zones.\n", count);
}
