/*
   Copyright (c) 2004 Chris Eagle (cseagle at nps d0t edu)
   
   Permission is hereby granted, free of charge, to any person obtaining a copy of 
   this software and associated documentation files (the "Software"), to deal in 
   the Software without restriction, including without limitation the rights to 
   use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of 
   the Software, and to permit persons to whom the Software is furnished to do so, 
   subject to the following conditions:
   
   The above copyright notice and this permission notice shall be included in all 
   copies or substantial portions of the Software.
   
   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS 
   FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR 
   COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER 
   IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/
 

//undo the onion layers that obfuscate the VM and the initial VM program

#include <idc.idc>

//backward distance from one decode loop to the next
#define JUMP_BACK 0xE6

//forward distance from decode loop to size of block to decode
#define SIZE 0xA4

//backward distance from decode loop to magic number in decded block
#define INNER_DEAD 0x28

static decode(addr, size) {
   auto data;
   do {
      data = Byte(addr);
      data = data ^ size;
      PatchByte(addr, data);
      addr = addr + 1;
      size = size - 1;
   } while (size != 0);
}

static main(void) {
  auto count, size;
  auto loopAddr, test;

  loopAddr = 0x00E2635B;
  count = 0;

   for (count = 0; count < 172; count++) {  //172 derived from testing
      size = Dword(loopAddr + SIZE);
      decode(loopAddr - size, size);
      MakeCode(loopAddr - size);
      test = Dword(loopAddr - INNER_DEAD);
      if (test != 0xDEAD) {
         Message("Bad magic at count %d\n", count);
         break;
      }
      loopAddr = loopAddr  - JUMP_BACK;
      MakeCode(loopAddr);
   }
   Message("Last decoded block: 0x%X - 0x%X\n", loopAddr - size, loopAddr - 1);
   Jump(loopAddr - size);
}
   