/*
   Copyright (c) 2004 Chris Eagle (cseagle at nps d0t edu)
   
   Permission is hereby granted, free of charge, to any person obtaining a copy of 
   this software and associated documentation files (the "Software"), to deal in 
   the Software without restriction, including without limitation the rights to 
   use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of 
   the Software, and to permit persons to whom the Software is furnished to do so, 
   subject to the following conditions:
   
   The above copyright notice and this permission notice shall be included in all 
   copies or substantial portions of the Software.
   
   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS 
   FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR 
   COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER 
   IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

//mimic the VM to decode the innermost 525 bytes which represent the VM 
//program to read the command line and authenticate the user before
//printing a message

/*
Initial state 

eax   0
ebx   DE863E
ecx   E1BA6D
edx   DE864E
eflags  2
ebp   0
esp   12FFFA0
esi   E1BA59
edi   E1B9F5
eip   E0D76F

popa/pusha sandwich with many dummy lines in between each

TOP:
*/

#include <idc.idc>

#define EVIL 0x00DE8736

static main(void) {
   auto eax, ebx, ecx, edx;
   auto ebp, esp, edi, esi;
   auto temp, dword_DE874A;
   
   eax = 0;
   ebx = 0xDE863E;
   ecx = 0xE1BA6D;
   edx = 0xDE864E;
//   eflags  2;
   ebp = 0;
//   esp   12FFFA0;
   esi = 0xE1BA59;
   edi = 0xE1B9F5;
//   eip   E0D76F;
   dword_DE874A = 0;

   while (1) {
      eax = Byte(esi + 2) & 0xFF;
      temp = Dword(EVIL + eax * 4);
      temp = temp + 1;
      PatchDword(EVIL + eax * 4, temp);
      if (temp == 0) {
         dword_DE874A = 0;
      }
      else {
         dword_DE874A = 1;
      }
      esi = esi + 3;
      
      eax = Byte(esi) & 0xFF;
      edi = Dword(0xE1B991 + eax * 4);
      eax = Byte(esi + 1) & 0xFF;

      eax = Byte(esi + 2) & 0xFF;
      temp = Dword(EVIL + eax * 4);
      temp = temp - 1;
      PatchDword(EVIL + eax * 4, temp);
      if (temp == 0) {
         dword_DE874A = 0;
      }
      else {
         dword_DE874A = 1;
      }
      
      esi = esi + 3;
      
      eax = Byte(esi) & 0xFF;
      edi = Dword(0xE1B991 + eax * 4);
      eax = Byte(esi + 1) & 0xFF;
      
      if (dword_DE874A == 0) {
         esi = esi + 6;

         eax = Byte(esi) & 0xFF;
         edi = Dword(0xE1B991 + eax * 4);
         eax = Byte(esi + 1) & 0xFF;
         break;
      }      

      esi = Dword(esi + 2);
      esi = 0xE1BA3E + esi;
      eax = Byte(esi) & 0xFF;

      edi = Dword(0xE1B991 + eax * 4);
      eax = Byte(esi + 1) & 0xFF;

      eax = Byte(esi + 2) & 0xFF;
      eax = Dword(EVIL + eax * 4);
      ecx = Byte(esi + 3) & 0xFF;

      ecx = Byte(esi + 4) & 0xFF;
      ecx = Dword(EVIL + ecx * 4);
      temp = Byte(ecx) ^ eax;
      PatchByte(ecx, temp);
      esi = esi + 5;
      eax = Byte(esi) & 0xFF;

      edi = Dword(0xE1B991 + eax * 4);
      eax = Byte(esi + 1) & 0xFF;
   }   
   
   Message("Execution completed after instruction 0x00E0873B\n");
   Message("eax = 0x%x\n", eax);
   Message("ebx = 0x%x\n", ebx);
   Message("ecx = 0x%x\n", ecx);
   Message("edx = 0x%x\n", edx);
   Message("esi = 0x%x\n", esi);
   Message("edi = 0x%x\n", edi);
   Jump(0x00E0873B);
}


//the code below is the virtual machine code that this idc script is mimicing

/*
DATA:00E0D4C6                 movzx   eax, byte ptr [esi+2]
DATA:00E0D76F                 inc     ds:Evil[eax*4]    //eax is 0 here,   Evil is 00DE8736
DATA:00E0D776                 jnz     loc_E0DCF2    -------|
...                                                        |
DATA:00E0DA49                 and     ds:dword_DE874A, 0   |
...                           jmp                  --------|------|  
...                                                        |      | 
DATA:00E0DCF2                 //pusha          <-----------|      |
DATA:00E0DF7A                 mov     ds:dword_DE874A, 1          |
                                                                  |
DATA:00E0E229                 add     esi, 3          <-----------|
...
DATA:00E0E4FA                 movzx   eax, byte ptr [esi]
...
DATA:00E0E7C1                 mov     edi, ds:dword_E1B991[eax*4]   //eax is 2 here? -> 0E1B9F5
DATA:00E0E7C8                 movzx   eax, byte ptr [esi+1]         
//to call at 00E0E7CD         jmp     [edi + eax * 4]

DATA:00E09D76                 movzx   eax, byte ptr [esi+2]
...
DATA:00E0A03E                 dec     ds:Evil[eax*4]               //eax is 3 here, this is the counter
DATA:00E0A045                 jnz     loc_E0A811    -------|
...                                                        |
DATA:00E0A2E4                 and     ds:dword_DE874A, 0   |
...                           jmp                  --------|------|  
...                                                        |      | 
DATA:00E0A811                 //pusha          <-----------|      |
DATA:00E0AACC                 mov     ds:dword_DE874A, 1          |
                                                                  |
DATA:00E0AD8F                 add     esi, 3          <-----------|

DATA:00E0B06B                 movzx   eax, byte ptr [esi]

DATA:00E0B31E                 mov     edi, ds:dword_E1B991[eax*4]  //eax is 4 here -> 0E1BA29

DATA:00E0B599                 movzx   eax, byte ptr [esi+1]

//to call at 00E0B59E        jmp     [edi + eax * 4]

DATA:00E07C49                 mov     eax, ds:dword_DE874A
DATA:00E07EF4                 test    eax, eax
DATA:00E07EF6                 jnz     loc_E08A51       -------------|
                                                                    |
DATA:00E081AF                 add     esi, 6                        |
DATA:00E08458                 movzx   eax, byte ptr [esi]           |
DATA:00E08734                 mov     edi, ds:dword_E1B991[eax*4]   |
DATA:00E0873B                 movzx   eax, byte ptr [esi+1]         |
//to call at 00E0B59E        jmp     [edi + eax * 4]   -------------|--------->  loop exit
                                                                    |
DATA:00E08CFE                 mov     esi, [esi+2]     <------------|    esi to 16 here?
DATA:00E08FC2                 lea     esi, dword_E1BA3E[esi]             esi to 00E1BA54
DATA:00E0925F                 movzx   eax, byte ptr [esi]

DATA:00E09511                 mov     edi, ds:dword_E1B991[eax*4]
DATA:00E097CF                 movzx   eax, byte ptr [esi+1]

//to call at 00E09A6C         jmp     [edi + eax * 4]

DATA:00DF7787                 movzx   eax, byte ptr [esi+2]
DATA:00DF7A49                 mov     eax, ds:Evil[eax*4]       eax is 2 here, this loads 53h
DATA:00DF7CF9                 movzx   ecx, byte ptr [esi+3]
DATA:00DF7FC4                 jmp     ds:off_E1B9E9[ecx*4]      ecx is 0 so this works out to 00DF7FCB (i.e no jump)

DATA:00DF8266                 movzx   ecx, byte ptr [esi+4]
DATA:00DF8532                 mov     ecx, ds:Evil[ecx*4]
DATA:00DF87CF                 xor     [ecx], al
DATA:00DF8A6F                 add     esi, 5
DATA:00DF8A72                 movzx   eax, byte ptr [esi]
DATA:00DF8D16                 mov     edi, ds:dword_E1B991[eax*4]
DATA:00DF8FFA                 movzx   eax, byte ptr [esi+1]

//to call at 00DF8FFF         jmp     [edi + eax * 4]   goto TOP

*/